local modPath = 'KingoftheHill'
local Config = import('/mods/kingofthehill/lua/kothConfig_HS.lua') --switched out later


--time accumulated in hill
local timeTable = {}
--time till respawn. -1 means alive
local respawnTime = {}
--number of deaths
local deathCount = {}
--unit to be respawned
local spawnUnit = {}
local spawnUnitID = {}

--hill info
local centerX
local centerY
local radius
local denom
local hillVoting = false

--voting stuff
local winTime = 1
local preVoteTime = 30
local NumVotesIn = 0
local NumVotingPlayers = 0
local VoteOver

function KingoftheHill()
	--LOG('koth stuff started')
	--set up score
	local brainIndex = 0
	for army, brain in ArmyBrains do
		if ArmyIsCivilian(army) == false then
			brainIndex = brainIndex + 1
			timeTable[brainIndex] = 0
			respawnTime[brainIndex] = -1
			deathCount[brainIndex] = 0
			spawnUnit[brainIndex] = brain:FindUnit(categories.ALLUNITS, false)
			spawnUnitID[brainIndex] = (spawnUnit[brainIndex]):GetBlueprint().BlueprintId
			--LOG('koth spawn ID is', spawnUnitID[brainIndex])
			brain.CalculateScore = kothScore
		end
	end
	
	
	--wait for short time before voting
	WaitSeconds(preVoteTime)
	hillVoting = true
	StartVote()
	WaitSeconds(Config.Vote.VotingTime)
	EndVote()
	local sizeX, sizeY = GetMapSize()
	centerX = sizeX/2
	centerY = sizeY/2
	radius = sizeX/denom
	--create hill markers
	CreateHill(centerX, centerY, radius)
	--LOG('koth created hill')
	
	
	

	--prompt win time
	Config = import('/mods/kingofthehill/lua/kothConfig_T.lua')
	hillVoting = false
	WaitSeconds(Config.Vote.VotingTime)
	NumVotesIn = 0
	StartVote()
	WaitSeconds(Config.Vote.VotingTime)
	EndVote()
	
	
	
	
	timeReached = false
	while timeReached ==false
	do
		brainIndex = 0
		--check in hill, add score if needed
		--if acu killed transfer score
		for army, brain in ArmyBrains do
			if ArmyIsCivilian(army) == false then
				brainIndex = brainIndex + 1
				if not brain:IsDefeated() then
					local acu = spawnUnit[brainIndex]
					if not acu:IsDead() then
						if inHill(acu, centerX, centerY, radius) and enemiesinHill(army) == false then
							timeTable[brainIndex] = timeTable[brainIndex] + 1
							local currentTime = timeTable[brainIndex]
							for army2, brain2 in ArmyBrains do
								if IsAlly(army, army2) and army != army2 then
									currentTime = currentTime + timeTable[getBrainIndex(brain2)]
								end
							end
							if currentTime == winTime - 60 then
								PrintText('1 minute remaining!', 20, nil, 10, 'center')
							elseif currentTime == winTime - 30 then
								PrintText('30 seconds remaining!', 20, nil, 10, 'center')
							elseif currentTime >= winTime then
								timeReached = true
								brain:OnVictory()
								WaitSeconds(5)
								EndGame()
							end
						end
					elseif respawnTime[brainIndex] == -1 then
						--LOG('koth acu died')
						--acu just died
						deathCount[brainIndex] = deathCount[brainIndex] + 1
						timeTable[brainIndex] = timeTable[brainIndex] - 200
						--spawn times increase to max of 40
						if deathCount[brainIndex] <= 3 then
							respawnTime[brainIndex] = deathCount[brainIndex] * 10
						else
							respawnTime[brainIndex] = 40
						end
					elseif respawnTime[brainIndex] == 0 then
						--LOG('koth respawn now')
						--time to respawn
						respawnACU(brain)
						respawnTime[brainIndex] = -1
					else
						--LOG('koth counting down now')
						--count down timer
						respawnTime[brainIndex] = respawnTime[brainIndex] - 1
					end
				end
			end
		end
		WaitSeconds(1)
	end
end


function CreateHill(centerX, centerY, radius)
	--spawn some sort of item at 8 points around circle
	--local proptest = CreatePropHPR( centerX+radius+radius, 0, centerY, 0, 0, 0)
	for army, brain in ArmyBrains do
		if ArmyIsCivilian(army) == false then
			local markerN = CreateUnitHPR("ueb5101", army, centerX, 0, centerY-radius, 0, 0, 0)
			makeSafe(markerN)
			local markerE = CreateUnitHPR("uab5101", army, centerX+radius, 0, centerY, 0, 0, 0)
			makeSafe(markerE)
			local markerS = CreateUnitHPR("ueb5101", army, centerX, 0, centerY+radius, 0, 0, 0)
			makeSafe(markerS)
			local markerW = CreateUnitHPR("uab5101", army, centerX-radius, 0, centerY, 0, 0, 0)
			makeSafe(markerW)
			local markerNE = CreateUnitHPR("urb5101", army, centerX+radius*math.sqrt(2)/2, 0, centerY-radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerNE)
			local markerSE = CreateUnitHPR("xsb5101", army, centerX+radius*math.sqrt(2)/2, 0, centerY+radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerSE)
			local markerSW = CreateUnitHPR("urb5101", army, centerX-radius*math.sqrt(2)/2, 0, centerY+radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerSW)
			local markerNW = CreateUnitHPR("xsb5101", army, centerX-radius*math.sqrt(2)/2, 0, centerY-radius*math.sqrt(2)/2, 0, 0, 0)
			makeSafe(markerNW)
		end
	end
end

function makeSafe(unit)
	unit:SetCanTakeDamage(false)
	unit:SetReclaimable(false)
	unit:SetCapturable(false)
end

function kothScore(self)
	local myIndex = getBrainIndex(self)
	return timeTable[myIndex]
end


function getBrainIndex(self)
	local brainIndex = 0
	for army, brain in ArmyBrains do
		if ArmyIsCivilian(army) == false then
			brainIndex = brainIndex + 1
			if brain == self
			then
				return brainIndex
			end
		end
	end
end

function inHill(acuiH, centerX, centerY, radius)
	local acuPos = acuiH:GetPosition()
	local dist = VDist2(acuPos[1], acuPos[3], centerX, centerY)
	if dist <= radius then
		--LOG('koth acu in hill')
		return true
	else
		--LOG('koth acu dist is', dist)
		return false
	end
end

function enemiesinHill(army)
	for army2, brain2 in ArmyBrains do
		local acu2 = brain2:FindUnit(categories.COMMAND, false)
		if acu2 and inHill(acu2, centerX, centerY, radius) and IsAlly(army, army2) == false and army != army2 then
			--LOG('koth enemies in hill')
			return true
		end
	end
	return false
end
			


function respawnACU(brain)
	--LOG('koth respawning')
	local faction = brain:GetFactionIndex()
	--LOG('koth respawn faction is', faction)
	local spawnPosX, spawnPosY = brain:GetArmyStartPos()
	local armyIndex = brain:GetArmyIndex()
	local bIndex = getBrainIndex(brain)
	spawnUnit[bIndex] = CreateUnitHPR(spawnUnitID[bIndex], armyIndex, spawnPosX, 0, spawnPosY, 0, 0, 0)
    spawnUnit[bIndex]:SetCustomName(brain.Nickname .. " V" .. deathCount[bIndex] + 1 .. ".0")
end


local function PlayerVoted(data)
	--LOG('koth playervoted')
    local playerId = data.From
    local playerName = data.Args.playerName
    local vote = data.Args.option

    if NumVotingPlayers > 0 and ArmyBrains[playerId].BrainType == 'Human' and not ArmyIsOutOfGame(playerId) then

        if Votes[vote] then
            Votes[vote] = Votes[vote] + 1
            NumVotesIn = NumVotesIn + 1
            Sync.kothNumVotesIn = NumVotesIn
            if NumVotesIn >= NumVotingPlayers or Votes[vote] > (NumVotingPlayers / 2) then
                EndVote()
            end
        else
            # unknown or illegal vote
            Sync.kothShowVoteUI = true
        end
    end
end




function StartVote()

    VoteOver = false

    # current number of votes for each vote option
    Votes = {}
    for k, v in Config.Vote.VoteOptions do
        Votes[k] = 0
    end

    # send this stuff to the UI layer
    Sync.kothVoteOptions = Config.Vote.VoteOptions
    Sync.kothVotes = Votes
    Sync.kothVoteTime = Config.Vote.VotingTime

    # using the query functionality to allow the UI send it's vote back to us
    import('/lua/SimPlayerQuery.lua').AddQueryListener("kothVote", PlayerVoted)

    # show voting UI for all relevant players
    if ArmyBrains[GetFocusArmy()].BrainType == 'Human' and not ArmyIsOutOfGame(GetFocusArmy()) then
        Sync.kothShowVoteUI = true
    end
    for army, brain in ArmyBrains do
        if brain.BrainType == 'Human' and not ArmyIsOutOfGame(army) then
            NumVotingPlayers = NumVotingPlayers + 1
        end
    end
end



function EndVote()
    if not VoteOver then

        VoteOver = true

        # hide vote UI for all players
        for army, brain in ArmyBrains do
            if brain.BrainType == 'Human' then
                Sync.kothShowVoteUI = false
            end
        end

        # get most voted option
        local winningOption = 0
        for option, numVotes in Votes do
            if numVotes > Votes[winningOption] or not Votes[winningOption] then
                winningOption = option
            end
        end

		if hillVoting then
			denom = Config.Vote.VoteOptions[winningOption].denom
		else
			winTime = Config.Vote.VoteOptions[winningOption].winTime
		end

        # tell players what option won the voting
        Sync.kothWinningOption = winningOption
        if ArmyBrains[GetFocusArmy()].BrainType == 'Human' or GetFocusArmy() == -1 then
            Sync.kothAnnounceVoteOver = true
        end
    end

end